package main;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

public class StartClass {

	private String tema;
	private List<Test> testList;
	private Boolean[] boolList;

	private JFrame mainFrame;

	private JMenuBar menuBar;

	private JMenu menuTest;
	private JMenu menuAbout;

	private JMenuItem menuItemNewTest;
	private JMenuItem menuItemExit;
	private JMenuItem menuItemAbout;

	private JPanel content;

	public StartClass() {

		menuBar = new JMenuBar();

		menuTest = new JMenu("Test");
		menuAbout = new JMenu("About Programm");

		menuItemNewTest = new JMenuItem("new testing");
		menuItemExit = new JMenuItem("Exit");
		menuItemAbout = new JMenuItem("About");

		menuTest.add(menuItemNewTest);
		menuTest.addSeparator();
		menuTest.add(menuItemExit);

		menuAbout.add(menuItemAbout);

		menuBar.add(menuTest);
		menuBar.add(menuAbout);

		addListners();

		content = new JPanel();
		content.setLayout(new BorderLayout(5, 5));

		mainFrame = new JFrame(IOFactory.getName());
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainFrame.setJMenuBar(menuBar);
		mainFrame.add(content);

		content.add(new InfoPanel(this));

		mainFrame.setResizable(false);
		mainFrame.setSize(600, 750);
		mainFrame.setVisible(true);
	}

	public static void main(String[] args) {
		new StartClass();

	}

	public void showInfoPanel() {
		content.removeAll();
		content.add(new InfoPanel(this));
		content.revalidate();
	}

	public void startTest() {
		showTems();

	}

	public void exit() {
		System.exit(0);
	}

	public void showTems() {
		content.removeAll();
		content.add(new TemaPanel(this));
		content.revalidate();
	}

	public void showTests(String name) {
		content.removeAll();
		tema = name;
		content.add(new TestPanel(this));
		content.revalidate();
	}

	public void showResult(List<Test> _testList, Boolean[] _boolList) {
		content.removeAll();
		testList = _testList;
		boolList = _boolList;
		content.add(new ResultPanel(this));
		content.revalidate();
	}

	public void showInfo(String name) {
		tema = name;
		content.removeAll();
		content.add(new InfoTestPanel(this));
		content.revalidate();
	}

	private void addListners() {
		menuItemExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});

		menuItemNewTest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showTems();
			}
		});

		menuItemAbout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showInfoPanel();
			}
		});
	}

	public String getTema() {
		return tema;
	}

	public Boolean[] getBoolList() {
		return boolList;
	}

	public List<Test> getTestList() {
		return testList;
	}
}
